#ifndef _DEStandardXover_h
#define _DEStandardXover_h

#include "deOp.h"

/** 

*/
template <class EOT>
class DEStandardXover : public DEOp<EOT>
{
  using DEOp<EOT>::parents;
  using DEOp<EOT>::id;

public:
  DEStandardXover(eoPop<EOT> & _parents, double _CR) : DEOp<EOT>(_parents), CR(_CR)
  {
  }

  /*
    Xover of the solution
  */
  virtual bool operator()(EOT & _solution) {
    unsigned jrand = rng.random(_solution.size());

    for(unsigned j = 0; j < jrand; j++) {
      if (rng.uniform() > CR)
        _solution[j] = parents[id][j];
    }

    for(unsigned j = 0; j < jrand + 1; j++) {
      if (rng.uniform() > CR)
        _solution[j] = parents[id][j];
    }

    _solution.invalidate();

    return true;
  }

protected:
  // crossover rate
  double CR;
};

#endif
